position proc near      ;mode 32b bon
                                                                
;entree:                              
;       plan = n du plan a utilise (<> du bios)
;       x,y = coordonee a trouver
                               
;sortie                         
;       eax = coordonnee dans la memoire
                                
        push ebx                
                                
        xor ebx,ebx             
        xor eax,eax             
                      
        push dx       
        xor dx,dx
        mov dl,plan
        mov ax,4000   
        mul dx
        pop dx
                      
                      
        add eax,0B8000h      ;j ai la coordonnee du plan en eax
                                
        mov bl,y                
        shl ebx,5     
        add eax,ebx             
        shl ebx,2                
        add eax,ebx     
        xor ebx,ebx   
        add bl,x            ;position dans la memoire a la coordonne plan;x;y
        shl ebx,1     
        add eax,ebx   
                      
                                                        
        pop ebx                 
                                
        ret                                                    
                                                               
        endp position

take    proc near       ; mode 32b ok
                                
;entree :                       
;       plan = numero du plan (<> du bios)                      
;       x,y = coordonnees
                                      
;sortie :                        
;       chr = charactere en 2 o
;               si on clip, chr=0
                          
        cmp x,0            
        jl fin_take 
        cmp x,79
        jg fin_take
        cmp y,0            
        jl fin_take
        cmp y,24       
        jg fin_take
                               
        push eax                   
    
        call position                 
        mov word ptr ax,[eax]
        mov chr,ax                                              
             
        pop eax
        ret                           
fin_take:                  
        mov chr,0          
        ret                
                           
        endp take          

tempo proc near ;       32b ok
;entree:                
;       temp    = temps (temp/18.2 = 1s)
;Sortie:                                
;       ecoulement du temps   
                        
        push eax        
        push bx                  
        push cx                  
        push dx         
                      
        mov bx,temp
                                                     
        mov ax,0h                                    
        int 1ah                                      
        push dx                                      
        dec bx                   
boucle6:                                             
        mov ax,0h                                    
        int 1ah                                      
        pop cx                                       
        push dx                                                 
        cmp cx,dx                                    
        je boucle6                                   
        dec bx                   
        cmp bx,0
        jnl boucle6           
                                                     
        pop dx          ;un pop pour virer le surplus
        pop dx      
        pop cx      
        pop bx      
        pop eax     
                    
        ret                      
        endp tempo 

cache_curseur proc near ;       32b ok
        push ax        
        push bx      
        push dx                
        mov ah,02h         
        mov bh,0              
        mov dh,80          
        mov dl,80          
        int 10h            
        pop dx
        pop bx
        pop ax   
        ret               
        endp cache_curseur
             
clear proc near         ;mode 32 bits bon
                              
;entree:                      
;       plan = numero du plan (<> du bios)
                      
;Sortie:                      
;       effacement du plan concernee
                   
        push eax               
        push dx    
        xor eax,eax
                    
        mov al,plan
        shl eax,12
        add eax,0b8000h
              
      	mov dx,0                 
boucle2:
       	mov word ptr [eax],0000h
     	inc eax               
        inc dx                
     	inc eax      
        inc dx  
     	cmp dx,4000
     	jne boucle2            
                               
        pop dx                 
        pop eax                 
                                
       	ret                     
        endp clear              

synchro proc near       ; 32b ok
        push dx    
        push ax
       
        mov dx,3dah              
                       
;@wait1:                      
;        in al,dx                                               
;        test ax,8h
;        jnz @wait1  
@wait2:           
        in al,dx  
        test ax,8h            
        jnz @wait2
                       
        pop ax    
        pop dx                 
        ret     
                 
        endp synchro
                   
put     proc near       ;mode 32b ok
                      
;entree : 
;       plan = numero du plan (<> du bios)
;       x,y = coordonnees
;       chr = characteres a afficher
                                                                
;sortie :
;       affichage du charactere
         
        push eax
        push bx
                           
        cmp x,0                  
        jl fin_put
        cmp x,79
        jg fin_put   
        cmp y,0     
        jl fin_put  
        cmp y,24
        jg fin_put
                      
        call position  
        mov bx,chr     
        mov word ptr [eax],bx
                                                                
fin_put:                                              
        pop bx               
        pop eax              
        ret                                           
        endp put                                      
                             
affichage proc near     ;mode 32b ok
                                 
;entree :                    
;       plan = numero du plan a transposer avec le plan 0 (<> du bios)
                             
;sortie :                    
;       affichage du plan    
                             
        push eax             
        push ebx             
        push cx              

        xor ebx,ebx

        push dx  
        xor dx,dx
        mov dl,plan
        mov ax,4000
        mul dx
        pop dx                        
                 
        add bx,ax
        add ebx,0B8000h 
                        
        mov eax,0B8000h 
boucle5:                
        mov word ptr cx,[ebx]
        mov word ptr [eax],cx
        add eax,2                
        add ebx,2
               
        cmp eax,0B8000h+4000
        jl boucle5
                    
        pop cx 
        pop ebx   
        pop eax                  
               
        ret            
        endp affichage                  
                               
                                    
